import java.awt.*;
import java.awt.event.*;

public class GameProc{

  boolean StartFlag = false;//true  : {[ł
                            //false : {[łO
  int GameWait = 5;  //Q[EFCg

  int life = 3; //c@
  int score = 0;//XRA
  int high_score = 0;//nCXRA

  Block block[] = new Block[iH.MaxBlockCnt];  // ubN

  Bar bar;  // Player
  Ball ball; // {[
  Ball oball;

  Stage stg;
  // --------------------------------------------------------------------------------------- //
  //                                                                                 //
  // --------------------------------------------------------------------------------------- //
  public GameProc(){
    int i;

    // vC[̃CX^X
    bar = new Bar();
    bar.setPos(300,450);
    bar.setSize(iH.BarWidth,iH.BarHeight);
    bar.show = true;

    // {[̃CX^X
    ball = new Ball();
    ball.width  = iH.BallWidth;
    ball.height = iH.BallHeight;
    ball.setPos(bar.x + bar.width / 2 - ball.width / 2, bar.y-ball.height );

    // (ItXN[){[̃CX^X
    oball = new Ball();
    oball.width  = iH.BallWidth;
    oball.height = iH.BallHeight;
    oball.show = true;

    stg = new Stage();
    stg.No = 5;
    stg.DataLoad(block);
  }

  // --------------------------------------------------------------------------------------- //
  //   L[Cxg                                                                         //
  // --------------------------------------------------------------------------------------- //
  public void RunKeyEvent(int key){
    switch(key){
      case 0:
        bar.Stop();
        break;
      case KeyEvent.VK_LEFT:
        bar.Left();
        break;
      case KeyEvent.VK_RIGHT:
        bar.Right();
        break;
      case KeyEvent.VK_SPACE:
        if(!StartFlag){BallShot(iH.BS_RAND);}
        break;
      case KeyEvent.VK_PAGE_UP:
        GameWait--;
        if(GameWait < 1){GameWait = 1;}
        break;
      case KeyEvent.VK_PAGE_DOWN:
        GameWait++;
        if(GameWait > 50){GameWait = 50;}
        break;
      case KeyEvent.VK_Z:
        if(!StartFlag){BallShot(iH.BS_LEFT);}
        break;
      case KeyEvent.VK_X:
        if(!StartFlag){BallShot(iH.BS_RIGHT);}
        break;
    }//--switch(key)
  }//--RunKeyEvent(int Key)

  // --------------------------------------------------------------------------------------- //
  //   `揈                                                                               //
  // --------------------------------------------------------------------------------------- //
  public void Paint(Graphics offScrGrp){

    int i;

    offScrGrp.setColor(Color.orange);
    offScrGrp.fillRect(0,0,iScr.width,iScr.height);

    offScrGrp.setColor(Color.black);
    offScrGrp.fillRect(iScr.left,iScr.top,iScr.right-iScr.left,iScr.bottom-iScr.top);
    offScrGrp.fillRect(10,420,10,50);

    offScrGrp.setColor(Color.red);
    offScrGrp.fillRect(10,420,10,GameWait);

    // {[\
    ball.Show(offScrGrp);

    // o[\
    bar.Show(offScrGrp);

    // ubN\
    for(i=0;i<stg.BlockCnt;i++){
      block[i].Show(offScrGrp);
    }

    offScrGrp.setColor(Color.black);
    offScrGrp.drawString(      "score:"+ score      , 30, 20);
    offScrGrp.drawString("high scrore:"+ high_score ,200, 20);
    offScrGrp.drawString(      "stage "+ stg.No     ,400, 20);
    offScrGrp.drawString(       "life:"+ life       ,570, 20);

    if(!StartFlag){
      offScrGrp.setColor(Color.white);
      offScrGrp.drawString("stage "  + stg.No,iScr.width /2 - 30,iScr.height/2 -20);
    }
  }


  // --------------------------------------------------------------------------------------- //
  //   Xbh                                                                            //
  // --------------------------------------------------------------------------------------- //
  public void RunThread(){

    int i;


      // ubNړ------------------------------------------
      for(i=0;i<stg.BlockCnt;i++){
        block[i].Move();
      }

      // o[ړ ---------------------------------------------
      bar.Move();

      if(StartFlag){//{[ł̏------------------------

        //{[ړ
        ball.Move();

        if(ball.bottom == (iScr.height-1)){//{[ɗ

          StartFlag = false;
          life--;

          if(life == 0){//Q[I[o[
            life = 3;
            bar.setPos(300,450);
            stg.No = 1;
            stg.DataLoad(block);
            score = 0;
          }
        }

        if(HitTest()){//蔻

          stg.NowBlockCnt -= 1;
          if(stg.NowBlockCnt == 0){ //̃Xe[W
            stg.NextStage(block);
            StartFlag = false;
          }

        }

      }else{  //{[łO
        ball.setPos(bar.x + bar.width / 2 - ball.width / 2, bar.y-ball.height );
      }

  }//-- run()

  // 蔻菈 ////////////////////////////////////////////////////////////////
  private boolean HitTest(){

    int i;
    boolean EndFlag = false;  // ftO
    boolean BreakBlock = false; // ubNꂽǂ

    // ubNւ̓蔻 ----------------------------------------------
    for(i=0;i<stg.BlockCnt;i++){
      if((ball.ObjHit(block[i]))&&(block[i].show)){

        BreakBlock = block[i].BallHit();
        EndFlag = true;
        score += block[i].score;
        if(BreakBlock){score += block[i].bk_score;}
        if(score > high_score){high_score = score;}

        switch(ball.getHitDir(block[i],oball)){
          case 1:
            ball.sp_x = -ball.sp_x;
            break;
          case 2:
            ball.sp_y = -ball.sp_y;
            break;
          case 3:
            ball.sp_x = -ball.sp_x;
            ball.sp_y = -ball.sp_y;
            break;
        }//--switch()
        break;
      }//--if(ObjHit(block[i]))
    }//--for(i)
    if(EndFlag){
      return BreakBlock;
    }

    // o[ւ̓蔻
    if(ball.ObjHit(bar)&&bar.show){
      switch(ball.getHitDir(bar,oball)){
        case 1:
          if(ball.sp_x == 0){ // o[~܂Ăꍇ
            ball.sp_x = -ball.sp_x;
          }else{              // o[ꍇ
            ball.sp_x = bar.sp_x;
          }
          break;
        case 2:
          ball.sp_y = -ball.sp_y;
          ball.sp_x += bar.sp_x / 10;
          if(ball.sp_x >  10){ball.sp_x =  10;}
          if(ball.sp_x < -10){ball.sp_x = -10;}
          break;
        case 3:
          ball.sp_x = -ball.sp_x;
          ball.sp_y = -ball.sp_y;
          break;
      }//--switch()
    }//--if(ball.ObjHit(bar)&&bar.show)

    // ǂւ̓蔻 -----------------------------------------------------------
    if(ball.left  <= iScr.left ){ball.sp_x = -ball.sp_x;ball.x = iScr.left              ;}
    if(ball.right >= iScr.right){ball.sp_x = -ball.sp_x;ball.x = iScr.right - ball.width;}
    if(ball.top   <= iScr.top  ){ball.sp_y = -ball.sp_y;ball.y = iScr.top               ;}


    return false;
  }

  // {[ˏ //////////////////////////////////////////////////////////////////////
  private void BallShot(int option){
    if((ball.x == (bar.x + bar.width / 2 - ball.width / 2))&&
       (ball.y == (bar.y-ball.height))){

       switch(option){
        case iH.BS_RAND :
          if((int)(Math.random()*2) == 1){
            ball.sp_x = 2;
          }else{
            ball.sp_x = -2;
          }
          break;
        case iH.BS_LEFT:
          ball.sp_x = -2;
          break;
        case iH.BS_RIGHT:
          ball.sp_x = 2;
          break;
      }

      ball.sp_y = -2;
      StartFlag = true;

    }//--if()
  }





}//--class GameProc